import java.awt.*;
import java.awt.geom.*;
import java.io.Serializable;

/**
 * Esta clase permite el despliegue en pantalla de un objeto Ball previamente inicializado
 * Por defecto las bolas son de color verde y representadas por un circulo.
 *
 * @version 0.4
*/

@SuppressWarnings("serial")

public class BallView implements Serializable {
	private Ellipse2D.Double shape = null;
	private Ball b;
	public Color color;
	
	/**
	* Constructor.
	* @param ball 	Objeto bola asociado a esta vista
	*/
	public BallView (Ball ball){
		b = ball;
		Vector2D c = b.getPosition();
		double radius = b.getRadius();
		shape = new Ellipse2D.Double(c.getX()-radius, c.getY()-radius, 2*radius, 2*radius);
		color = Color.GREEN;
	}
	/**
	* Metodo que redibuja la bola.
	* @param g 	Objeto Graphics2D para manejar la vista
	*/
	public void draw (Graphics2D g){
		Vector2D c = b.getPosition();
		double radius = b.getRadius();	
		shape.setFrame(c.getX()-radius, c.getY()-radius, 2*radius, 2*radius);
		g.setColor(color);
		g.fill(shape);
	}
}