import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.JMenuItem;
import java.lang.*;

public class FileMenuListener implements ActionListener {
	private MyWorld world;
	JFileChooser fc; 
	JTextArea log;
	
	public FileMenuListener (MyWorld w){
		world = w;
		fc = new JFileChooser();
		log = new JTextArea(5,20);
		log.setMargin(new Insets(5,5,5,5));
		log.setEditable(false);
	}
	public void actionPerformed(ActionEvent e) {
		JMenuItem menuItem = (JMenuItem)(e.getSource());
		String text = menuItem.getText();

		if (text.equals("Open") && world.isWorldOFF()){

			int returnVal = fc.showOpenDialog(null);

			if (returnVal == JFileChooser.APPROVE_OPTION){
				ArrayList<PhysicsElement> newElements = new ArrayList<PhysicsElement>();
				File file = fc.getSelectedFile();

				try{
					ObjectInputStream in =  new ObjectInputStream(new FileInputStream(file));
					world.removeElements();
					newElements = (ArrayList<PhysicsElement>)in.readObject();
					in.close();
					for(PhysicsElement pe: newElements){
						if(pe instanceof Spring){
							Spring se = (Spring) pe;
							se.setWorld(world);
							}
						world.addElement(pe);
					}
				} catch(FileNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					//newElements = new ArrayList<PhysicsElement>();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (ClassNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
			else {
				log.append("Open command cancelled by user.\n");
				log.setCaretPosition(log.getDocument().getLength());
			}

		}
		else if (text.equals("Save As...") && world.isWorldOFF()){

			world.printStateDescription();
			world.printState(world.getT());
			
			int returnVal = fc.showSaveDialog(null);

			if (returnVal == JFileChooser.APPROVE_OPTION){
				// save all the physical elements to the file settings.dat
				File file = fc.getSelectedFile();
				ObjectOutputStream out; 

				try {
					out = new ObjectOutputStream(new FileOutputStream(file));
					ArrayList<PhysicsElement> elem = world.getPhysicsElements(); 
					out.writeObject(elem);
					out.close();
				} catch (FileNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
			else {
				log.append("Save command cancelled by user.\n");
				log.setCaretPosition(log.getDocument().getLength());
			}
		}
	}
}

